package com.ifp.vault.emf.provider;

import javax.persistence.EntityManagerFactory;

import java.util.HashMap;

import org.eclipse.persistence.jpa.PersistenceProvider;
import org.osgi.framework.BundleActivator;
import org.osgi.framework.BundleContext;
import org.osgi.framework.ServiceRegistration;

import com.ifp.vault.emf.provider.impl.EntityManagerFactoryProviderImpl;
import com.ifp.vault.emf.provider.impl.SampleOSGiServiceImpl;


public class Activator implements BundleActivator {
	EntityManagerFactoryProvider entityManagerFactoryProvider;
	SampleOSGiService sampleOSGiService;
	ServiceRegistration<EntityManagerFactoryProvider> providerServiceRegistration;
	ServiceRegistration<SampleOSGiService> sampleOSGiServiceServiceRegistration;

	@Override
	public void start(BundleContext context) throws Exception {
		ClassLoader old = Thread.currentThread().getContextClassLoader();
		try {
			Thread.currentThread().setContextClassLoader(getClass().getClassLoader());
			EntityManagerFactory entityManagerFactory = new PersistenceProvider().createEntityManagerFactory("pu1",
					new HashMap());

			entityManagerFactoryProvider = new EntityManagerFactoryProviderImpl(entityManagerFactory);

			providerServiceRegistration = context.registerService(EntityManagerFactoryProvider.class, entityManagerFactoryProvider, null);

			// register the sample service
			sampleOSGiService = new SampleOSGiServiceImpl();

			sampleOSGiServiceServiceRegistration = context.registerService(SampleOSGiService.class, sampleOSGiService, null);
		} finally {
			Thread.currentThread().setContextClassLoader(old);
		}
	}

	@Override
	public void stop(BundleContext context) throws Exception {
		providerServiceRegistration.unregister();
		sampleOSGiServiceServiceRegistration.unregister();
	}
}
